dnl  The local macros for autoconf.
dnl
dnl  This file is a part of Opal. See the Opal www page at
dnl  http://www.fi.muni.cz/~kas/opal for details.
dnl
dnl  Copyright (C) 1995-1998  Jan "Yenya" Kasprzak <kas@fi.muni.cz>
dnl
dnl  This program is free software; you can redistribute it and/or modify
dnl  it under the terms of the GNU General Public License as published by
dnl  the Free Software Foundation; either version 2 of the License, or
dnl  (at your option) any later version.
dnl
dnl  This program is distributed in the hope that it will be useful,
dnl  but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl  GNU General Public License for more details.
dnl
dnl  You should have received a copy of the GNU General Public License
dnl  along with this program; if not, write to the Free Software
dnl  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
dnl
AC_DEFUN(AC_PROG_F77,
[AC_CHECK_PROGS(FC, g77 f77 fort77)
if test -z "$FC"
then
	AC_MSG_ERROR(cannot find a Fortran 77 compiler in \$PATH)
fi

AC_PROG_F77_WORKS
AC_PROG_F77_GNU
])

AC_DEFUN(AC_TRY_F77,
[cat >conftest.f <<EOF
[#]line __oline__ "configure"
[$1]
EOF
if $FC $FFLAGS $LDFLAGS -o conftest conftest.f >&AC_FD_CC 2>&1
then
	[$2]=yes
	ifelse([$3],,,dnl
        if ./conftest 2>/dev/null; then
		[$3]=no
	else
		[$3]=yes
	fi)
else
	[$2]=no
fi
rm -f conftest*])

AC_DEFUN(AC_PROG_F77_WORKS,
[AC_MSG_CHECKING([whether the Fortran 77 compiler ($FC $FFLAGS $LDFLAGS) works])
AC_TRY_F77([
      stop
      end
], ac_cv_prog_f77_works, ac_cv_prog_f77_cross)
AC_MSG_RESULT($ac_cv_prog_f77_works)
if test $ac_cv_prog_f77_works = no
then
   AC_MSG_ERROR([installation or configuration problem: F77 compiler cannot create executables.])
fi
AC_MSG_CHECKING([whether the Fortran 77 compiler ($FC $FFLAGS $LDFLAGS) is a cross-compiler])
AC_MSG_RESULT($ac_cv_prog_f77_cross)
cross_compiling=$ac_cv_prog_f77_cross
])

AC_DEFUN(AC_PROG_F77_GNU,
[AC_MSG_CHECKING([whether we are using GNU f77])
if AC_TRY_COMMAND(${FC} -v 2>&1 ) | egrep gcc >/dev/null 2>&1; then
	ac_cv_prog_g77=yes
else
	ac_cv_prog_g77=no
fi
AC_MSG_RESULT($ac_cv_prog_g77)
])

AC_DEFUN(AC_TEST_CFLAGS,
[for ac_cv_cc_testing_flag in $1
do
	ac_save_CFLAGS="[$]CFLAGS"
	CFLAGS="[$CFLAGS] [$ac_cv_cc_testing_flag]"
	AC_MSG_CHECKING([whether the C compiler accepts the $ac_cv_cc_testing_flag])
	AC_TRY_RUN(main(){exit(0);},ac_cv_cc_flag_works=YES,ac_cv_cc_flag_works=NO,false)
	CFLAGS="[$]ac_save_CFLAGS"
	if test "[$ac_cv_cc_flag_works]" = "YES"
	then
		AC_MSG_RESULT(yes)
		ifelse([$2], ,[CFLAGS="[$]CFLAGS [$]ac_cv_cc_testing_flag"],[$2])
	else
		AC_MSG_RESULT(no)
		ifelse([$3], , :, [$3])
	fi
done
])

AC_DEFUN(AC_TEST_FFLAGS,
[
for ac_cv_fc_testing_flag in $1
do
	ac_save_FFLAGS="[$]FFLAGS"
	FFLAGS="[$FFLAGS] [$ac_cv_fc_testing_flag]"
	AC_MSG_CHECKING([whether the F77 compiler afcepts the $ac_cv_fc_testing_flag])
	AC_TRY_F77([
      stop
      end
], ac_cv_fc_flag_works)
	FFLAGS="[$]ac_save_FFLAGS"
	if test "[$ac_cv_fc_flag_works]" = "yes"
	then
		AC_MSG_RESULT(yes)
		ifelse([$2], ,[FFLAGS="[$]FFLAGS [$]ac_cv_fc_testing_flag"], [$2])
	else
		AC_MSG_RESULT(no)
		ifelse([$3], , :, [$3])
	fi
done
])

AC_DEFUN(AC_ADD_FIRST_WORKING_CFLAG,
[AC_TEST_CFLAGS($1,CFLAGS="$CFLAGS $ac_cv_cc_testing_flag"; break)]
)

AC_DEFUN(AC_ADD_FIRST_WORKING_FFLAG,
[AC_TEST_FFLAGS($1,FFLAGS="$FFLAGS $ac_cv_fc_testing_flag"; break)]
)

